<template lang="pug">
div
  //- inspiration
  div(v-if="canUpload(0)")
    .text-center.q-my-lg
      q-icon(:name="matEmojiObjects", size="lg")
      .text-h6 {{ $t(`phase_${phase}_info_title_1`) }}
    //- FormTextInput(
    //-   ref="field1",
    //-   v-model="submission.formdata.inspiration",
    //-   name="inspiration",
    //-   :icon="matDescription",
    //-   :disable="submission.id ? true : false"
    //- )
    FormFileInput(
      ref="field2",
      v-on:rejected="$emit('rejected')",
      v-model="files[0]"
    )

  //- problem
  div(v-if="canUpload(1)")
    .text-center.q-my-lg
      q-icon(name="un:debris-management", size="lg")
      .text-h6 {{ $t(`phase_${phase}_info_title_2`) }}
    //- FormTextInput(
    //-   ref="field3",
    //-   v-model="submission.formdata.problem",
    //-   name="problem",
    //-   :icon="matDescription",
    //-   :disable="submission.id ? true : false"
    //- )
    FormFileInput(
      ref="field4",
      v-on:rejected="$emit('rejected')",
      v-model="files[1]"
    )

  //- idea
  div(v-if="canUpload(2)")
    .text-center.q-my-lg
      q-icon(name="un:innovation", size="lg")
      .text-h6 {{ $t(`phase_${phase}_info_title_3`) }}
    //- FormTextInput(
    //-   ref="field5",
    //-   v-model="submission.formdata.title",
    //-   name="idea",
    //-   :icon="matDescription",
    //-   :disable="submission.id ? true : false"
    //- )
    FormFileInput(
      ref="field6",
      v-on:rejected="$emit('rejected')",
      v-model="files[2]"
    )

  //- impact on community
  //- div(v-if="canUpload(3)")
  //-   .text-center.q-my-lg
  //-     q-icon(name="un:leadership", size="lg")
  //-     .text-h6 {{ $t('submit_info_title_2') }}
  //-   FormTextInput(
  //-     ref="field3",
  //-     v-model="submission.formdata.impact",
  //-     name="impact",
  //-     :icon="matDescription",
  //-     :disable="submission.id ? true : false"
  //-   )
  //-   FormFileInput(
  //-     ref="field4",
  //-     v-on:rejected="$emit('rejected')",
  //-     v-model="files[3]"
  //-   )

  //- why me?
  //- div(v-if="canUpload(4)")
    //- .text-center.q-my-lg
    //-   q-icon(:name="matPerson", size="lg")
    //-   .text-h6 {{ $t('submit_info_title_3') }}
    //- FormTextInput(
    //-   ref="field9",
    //-   v-model="submission.formdata.whyme",
    //-   name="whyme",
    //-   :icon="matDescription",
    //-   :disable="submission.id ? true : false"
    //- )
    //- FormFileInput(
    //-   ref="field10",
    //-   v-on:rejected="$emit('rejected')",
    //-   v-model="files[4]"
    //- )

  //- Team
  //- div(v-if="!submission.id && !loading")
  //-   .text-center.q-my-lg
  //-     q-icon(:name="matGroups", size="lg")
  //-     .text-h6 {{ $t('myteam') }}
  //-     .text-body1 {{ $t('team_text') }}

  //-   .row
  //-     .col-auto
  //-       q-icon.on-left.q-pt-sm(:name="matGroup", size="lg", color="grey-7")
  //-     .col.q-py-sm.full-width
  //-       .fieldborder.rounded-borders
  //-         q-list(separator)
  //-           q-item.q-my-sm
  //-             q-item-section
  //-               q-item-label {{ user.displayName }}
  //-               q-item-label(caption) {{ user.email }}
  //-           q-item.q-my-sm(
  //-             v-for="(person, index) in team",
  //-             :key="person.email"
  //-           )
  //-             q-item-section
  //-               q-item-label {{ person.name }}
  //-               q-item-label(caption) {{ person.email }}
  //-             q-item-section(side)
  //-               q-btn(
  //-                 :icon="matDelete",
  //-                 round,
  //-                 flat,
  //-                 @click="removePerson(index)"
  //-               )
  //-           q-item.q-my-sm
  //-             q-item-section
  //-               q-input(
  //-                 dense,
  //-                 v-model="newperson.name",
  //-                 ref="name",
  //-                 flat,
  //-                 :label="$t('team_name')",
  //-                 :error="nameinvalid",
  //-                 :error-message="$t('requires_name')"
  //-               )
  //-             q-item-section
  //-               q-input(
  //-                 dense,
  //-                 v-model="newperson.email",
  //-                 flat,
  //-                 ref="email",
  //-                 :label="$t('team_email')",
  //-                 type="email",
  //-                 :error="emailinvalid",
  //-                 :error-message="$t('requires_email')"
  //-               )
  //-             q-item-section(side)
  //-               q-btn(@click="addPerson()", flat, round, :icon="matAdd")
</template>

<script>
import FormTextInput from "@/components/FormTextInput";
import FormFileInput from "@/components/FormFileInput";
import { mapState } from "vuex";

export default {
  name: "PhaseSubmission",
  components: {
    FormTextInput,
    FormFileInput,
  },
  data: () => {
    return {
      newperson: {
        name: "",
        email: "",
      },
      team: [],
      nameinvalid: false,
      emailinvalid: false,
    };
  },
  methods: {
    validateMe() {
      // if (!this.$refs.field1.validate()) return false;
      if (!this.$refs.field2.validate()) return false;
      // if (!this.$refs.field3.validate()) return false;
      if (!this.$refs.field4.validate()) return false;
      // if (!this.$refs.field5.validate()) return false;
      if (!this.$refs.field6.validate()) return false;
      return true;
    },
    removePerson(index) {
      this.team.splice(index, 1);
    },
    addPerson() {
      if (!this.newperson.name) this.nameinvalid = true;
      if (!this.newperson.email) this.emailinvalid = true;

      if (this.newperson.name && this.newperson.email) {
        this.team.push(this.newperson);
        this.newperson = { name: "", email: "" };
        this.$refs.email.resetValidation();
        this.$refs.name.resetValidation();
      }
    },
    canUpload(index) {
      if (!this.neededFiles) return true;
      else if (this.neededFiles[index]) return true;
      else return false;
    },
  },
  watch: {
    team: {
      deep: true,
      handler() {
        this.submission.team = this.team;
      },
    },
  },
  computed: {
    ...mapState(["user"]),
  },
  props: [
    "files",
    "submission",
    "languageList",
    "commsLanguages",
    "countryList",
    "neededFiles",
    "loading",
    "phase",
  ],
};
</script>

<style lang="scss" scoped>
// @import "@/styles/quasar.variables.scss";
.fieldborder {
  border-color: #bdbdbd;
  border-width: 1px;
  border-style: solid;
}
</style>
